/**
 * This interface contains all operations that all types of shapes should
 * support.
 */
public interface Shape {

  /**
   * Returns the distance of this shape from the origin. The distance is
   * measured from whatever reference position a shape is (e.g. a center for a
   * circle)
   *
   * @return the distance from the origin
   */
  double distToOrigin();

  //NOTE: we removed area(), perimeter() and resize(...) and implemented them
  // as visitors
  void accept(ShapeVisitor visitor);

}
